#ifndef _POLY_H
#define _POLY_H

#include <stdio.h>
#include <stdlib.h>
#include <gmp.h>

#include "config.h"
#define POLY_MAX_DEG    (10)

typedef struct _poly{
    int deg;
    mpz_t k[POLY_MAX_DEG];
    double d[POLY_MAX_DEG];
    
    int realRootsNumber;
    double roots[POLY_MAX_DEG];
    
    mpz_t yi,ki;
} poly_s, *poly_t;

int poly_load(FILE *fin, poly_t F);
void poly_destroy(poly_t F);

int poly_has_roots_in(poly_t F, int64_t x, int64_t y);
void poly_value(poly_t F, int64_t x, int64_t y, mpz_t val);

double poly_estimate(poly_t F, int64_t x, int64_t y);

void poly_lift_root(poly_t F, int64_t invdf, int64_t p, int64_t* pk, int64_t* r);
void poly_lift_inf_root(poly_t F, int64_t invdf, int64_t p, int64_t* pk, int64_t* r);

#endif
