#ifndef _RELATIONS_H
#define _RELATIONS_H

#include <stdio.h>
#include <stdint.h>
#include <gmp.h>

#include "config.h"
#include "log.h"
#include "polynomial.h"
#include "base.h"

typedef struct _factorization {
    int bigPrimesNumber, alphasNumber;
    int alphas[MAX_ALPHAS][2]; // ...; index, power; ...
    mpz_t bp1, bp2;
} factorization;

gmp_randstate_t randstate;

void checkXY(sieveBase *B, poly *P, int64_t x, int64_t y, factorization *result);
void serialize(FILE *fout, int64_t x, int64_t y, factorization *facF, factorization *facG);

#endif
